--[[
Don't edit or remove this comment block! It is used by the editor to store information since i'm too lazy to write a good LUA parser... -Haz
SETTINGS
RestrictedEnhancements=
RestrictedCategories=
END
--]]

local ScenarioUtils = import('/lua/sim/ScenarioUtilities.lua')
local ScenarioFramework = import('/lua/ScenarioFramework.lua')

#This goes in the _script.lua file

function OnPopulate()
  #Map Maker: Set this to the map size
  local MapMaxSize = 1024

  #Map Maker, note the comments in this section to know the names of each marker
  #The points start on their opposent sides. Note, this is a percentage of the size of the map
  local MapTU = 100.0;#Top left corner, Upwards direction
  local MapTL = 100.0;#Top left corner, Leftwards direction
  local MapBD = 0.0;#Bottom right corner, Downwards direction
  local MapBR = 0.0;#Bottom right corner, Rightwards direction

  #Map Maker: For each number inside the "math.min/max", set that number to the percentage of
  #the map that the marker should be moved.
  #The top left corner is 0, the bottom right corner is 100
  for a, v in ListArmies() do
    
    if 'ARMY_1' == v then
      LOG('Debug LVW: OnPopulate: I see ARMY_1 ')
      MapTU = math.min(MapTU, 2.5);
      MapTL = math.min(MapTL, 2.5);
      MapBD = math.max(MapBD, 33.4);
      MapBR = math.max(MapBR, 33.4);
    end #ARMY_1
    
    if 'ARMY_2' == v then
      LOG('Debug LVW: OnPopulate: I see ARMY_2 ')
      MapTU = math.min(MapTU, 2.5);
      MapTL = math.min(MapTL, 33.3);
      MapBD = math.max(MapBD, 33.4);
      MapBR = math.max(MapBR, 66.4);
    end #ARMY_2
    
    if 'ARMY_3' == v then
    LOG('Debug LVW: OnPopulate: I see ARMY_3 ')
      MapTU = math.min(MapTU, 2.5);
      MapTL = math.min(MapTL, 66.3);
      MapBD = math.max(MapBD, 33.4);
      MapBR = math.max(MapBR, 98.5);
    end #ARMY_3
    
    if 'ARMY_4' == v then
      LOG('Debug LVW: OnPopulate: I see ARMY_4 ')
      MapTU = math.min(MapTU, 33.3);
      MapTL = math.min(MapTL, 66.6);
      MapBD = math.max(MapBD, 66.6);
      MapBR = math.max(MapBR, 98.5);
    end #ARMY_4
    
    if 'ARMY_5' == v then
      LOG('Debug LVW: OnPopulate: I see ARMY_5 ')
      MapTU = math.min(MapTU, 66.6);
      MapTL = math.min(MapTL, 66.6);
      MapBD = math.max(MapBD, 98.5);
      MapBR = math.max(MapBR, 98.5);
    end #ARMY_5
    
    if 'ARMY_6' == v then
      LOG('Debug LVW: OnPopulate: I see ARMY_6 ')
      MapTU = math.min(MapTU, 66.6);
      MapTL = math.min(MapTL, 33.3);
      MapBD = math.max(MapBD, 98.5);
      MapBR = math.max(MapBR, 66.6);
    end #ARMY_6
    
    if 'ARMY_7' == v then
      LOG('Debug LVW: OnPopulate: I see ARMY_7 ')
      MapTU = math.min(MapTU, 66.6);
      MapTL = math.min(MapTL, 2.5);
      MapBD = math.max(MapBD, 98.5);
      MapBR = math.max(MapBR, 33.4);
    end #ARMY_7

    if 'ARMY_8' == v then
      LOG('Debug LVW: OnPopulate: I see ARMY_8 ')
      MapTU = math.min(MapTU, 33.3);
      MapTL = math.min(MapTL, 2.5);
      MapBD = math.max(MapBD, 66.6);
      MapBR = math.max(MapBR, 33.4);
    end #ARMY_8
    
  end #for each ARMY
  
  MapTL = (MapTL * MapMaxSize) / 100;
  MapTU = (MapTU * MapMaxSize) / 100;
  MapBR = (MapBR * MapMaxSize) / 100;
  MapBD = (MapBD * MapMaxSize) / 100;
    
  #Make it so.
  local RectMap = Rect(MapTL, MapTU, MapBR, MapBD)
  ScenarioFramework.SetPlayableArea(RectMap , false)
  
  ScenarioUtils.InitializeArmies()
  LOG('Debug LVW: OnPopulate End')
end #OnPopulate

function OnStart(self)
end
